﻿using System;
using System.Collections.Generic;
using System.Text;

namespace CH372UpDown
{
    partial class Form1
    {
        public const uint GENERIC_READ  =0x80000000;
        public const uint GENERIC_WRITE = 0x40000000;
        public const uint FILE_SHARE_READ  = 0x00000001;
        public const uint FILE_SHARE_WRITE = 0x00000002;
        public const uint OPEN_EXISTING = 3;
        public const uint FILE_ATTRIBUTE_NORMAL = 0x00000080;
        public UInt32 mStrToBcd(string str)
        {
            int mlen, i = 0;
            byte iChar = 0;
            byte[] Des = new byte[9];
            UInt32 mBCD = 0;
            UInt32 de = 1;
            byte[] StrArray = Encoding.Default.GetBytes(str);
            mlen = str.Length;
            for (i = mlen - 1; i >= 0; i--)
            {
                iChar = StrArray[i];
                if (iChar >= '0' && iChar <= '9')
                    mBCD = mBCD + Convert.ToUInt32(iChar - '0') * de;
                else if (iChar >= 'A' && iChar <= 'F')
                    mBCD = mBCD + Convert.ToUInt32(iChar - 'A' + 0x0a) * de;
                else if (iChar >= 'a' && iChar <= 'f')
                    mBCD = mBCD + Convert.ToUInt32(iChar - 'a' + 0x0a) * de;
                else return (0);
                de *= 10;//16
            }
            return (mBCD);
        }
        byte[] mStrtoVal(byte[] str, UInt32 strlen)
        {
            UInt32 i, j;
            UInt32 len;
            byte[] strRev = new byte[CH375DLL.mMAX_BUFFER_LENGTH];
            if (strlen % 2 != 0)
            {
                str[strlen] = 0;
                strlen += 1;
            }
            len = strlen / 2;
            for (i = 0, j = 0; j < len; i++, j++)
            {
                strRev[j] = (byte)((mCharToBcd(str[i]) << 4) + mCharToBcd(str[i + 1]));
                i++;
            }
            return strRev;
        }
        byte mCharToBcd(byte iChar)
        {
            byte mBCD;
            if (iChar >= '0' && iChar <= '9') mBCD = Convert.ToByte(iChar - '0');
            else if (iChar >= 'A' && iChar <= 'F') mBCD = Convert.ToByte(iChar - 'A' + 0x0a);
            else if (iChar >= 'a' && iChar <= 'f') mBCD = Convert.ToByte(iChar - 'a' + 0x0a);
            else mBCD = 0x00;
            return (mBCD);
        }
        public void mem_cpy(byte[] dst, int dst_offset, byte[] src, int src_offset, UInt32 len)
        {
            int j = dst_offset;
            int k = src_offset;
            for (int i = 0; i < len; i++)
            {
                dst[j] = src[k];
                j++;
                k++;
            }
        }
    }
}
